<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!--NewPage-->
<HTML>
<HEAD>
<!-- Generated by javadoc (build 1.5.0_17) on Fri Dec 04 18:31:08 CET 2009 -->
<TITLE>
BornDieController
</TITLE>

<META NAME="keywords" CONTENT="ch.javasoft.metabolic.efm.borndie.BornDieController class">

<LINK REL ="stylesheet" TYPE="text/css" HREF="../../../../../stylesheet.css" TITLE="Style">

<SCRIPT type="text/javascript">
function windowTitle()
{
    parent.document.title="BornDieController";
}
</SCRIPT>
<NOSCRIPT>
</NOSCRIPT>

</HEAD>

<BODY BGCOLOR="white" onload="windowTitle();">


<!-- ========= START OF TOP NAVBAR ======= -->
<A NAME="navbar_top"><!-- --></A>
<A HREF="#skip-navbar_top" title="Skip navigation links"></A>
<TABLE BORDER="0" WIDTH="100%" CELLPADDING="1" CELLSPACING="0" SUMMARY="">
<TR>
<TD COLSPAN=2 BGCOLOR="#EEEEFF" CLASS="NavBarCell1">
<A NAME="navbar_top_firstrow"><!-- --></A>
<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="3" SUMMARY="">
  <TR ALIGN="center" VALIGN="top">
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../../overview-summary.html"><FONT CLASS="NavBarFont1"><B>Overview</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="package-summary.html"><FONT CLASS="NavBarFont1"><B>Package</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#FFFFFF" CLASS="NavBarCell1Rev"> &nbsp;<FONT CLASS="NavBarFont1Rev"><B>Class</B></FONT>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="class-use/BornDieController.html"><FONT CLASS="NavBarFont1"><B>Use</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="package-tree.html"><FONT CLASS="NavBarFont1"><B>Tree</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../../deprecated-list.html"><FONT CLASS="NavBarFont1"><B>Deprecated</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../../index-files/index-1.html"><FONT CLASS="NavBarFont1"><B>Index</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../../help-doc.html"><FONT CLASS="NavBarFont1"><B>Help</B></FONT></A>&nbsp;</TD>
  </TR>
</TABLE>
</TD>
<TD ALIGN="right" VALIGN="top" ROWSPAN=3><EM>
</EM>
</TD>
</TR>

<TR>
<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
&nbsp;PREV CLASS&nbsp;
&nbsp;<A HREF="../../../../../ch/javasoft/metabolic/efm/borndie/BornDieDoubleDescriptionImpl.html" title="class in ch.javasoft.metabolic.efm.borndie"><B>NEXT CLASS</B></A></FONT></TD>
<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
  <A HREF="../../../../../index.html?ch/javasoft/metabolic/efm/borndie/BornDieController.html" target="_top"><B>FRAMES</B></A>  &nbsp;
&nbsp;<A HREF="BornDieController.html" target="_top"><B>NO FRAMES</B></A>  &nbsp;
&nbsp;<SCRIPT type="text/javascript">
  <!--
  if(window==top) {
    document.writeln('<A HREF="../../../../../allclasses-noframe.html"><B>All Classes</B></A>');
  }
  //-->
</SCRIPT>
<NOSCRIPT>
  <A HREF="../../../../../allclasses-noframe.html"><B>All Classes</B></A>
</NOSCRIPT>


</FONT></TD>
</TR>
<TR>
<TD VALIGN="top" CLASS="NavBarCell3"><FONT SIZE="-2">
  SUMMARY:&nbsp;NESTED&nbsp;|&nbsp;FIELD&nbsp;|&nbsp;<A HREF="#constructor_summary">CONSTR</A>&nbsp;|&nbsp;<A HREF="#method_summary">METHOD</A></FONT></TD>
<TD VALIGN="top" CLASS="NavBarCell3"><FONT SIZE="-2">
DETAIL:&nbsp;FIELD&nbsp;|&nbsp;<A HREF="#constructor_detail">CONSTR</A>&nbsp;|&nbsp;<A HREF="#method_detail">METHOD</A></FONT></TD>
</TR>
</TABLE>
<A NAME="skip-navbar_top"></A>
<!-- ========= END OF TOP NAVBAR ========= -->

<HR>
<!-- ======== START OF CLASS DATA ======== -->
<H2>
<FONT SIZE="-1">
ch.javasoft.metabolic.efm.borndie</FONT>
<BR>
Class BornDieController&lt;Col extends <A HREF="../../../../../ch/javasoft/metabolic/efm/column/Column.html" title="interface in ch.javasoft.metabolic.efm.column">Column</A>&gt;</H2>
<PRE>
<A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Object.html" title="class or interface in java.lang">java.lang.Object</A>
  <IMG SRC="../../../../../resources/inherit.gif" ALT="extended by "><B>ch.javasoft.metabolic.efm.borndie.BornDieController&lt;Col&gt;</B>
</PRE>
<HR>
<DL>
<DT><PRE>public class <A HREF="../../../../../src-html/ch/javasoft/metabolic/efm/borndie/BornDieController.html#line.72"><B>BornDieController&lt;Col extends <A HREF="../../../../../ch/javasoft/metabolic/efm/column/Column.html" title="interface in ch.javasoft.metabolic.efm.column">Column</A>&gt;</B></A><DT>extends <A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Object.html" title="class or interface in java.lang">Object</A></DL>
</PRE>

<P>
The <code>BornDieController</code> controls the born/die algorithm. After
 instantiating a controller, the algorithm is 
 <A HREF="../../../../../ch/javasoft/metabolic/efm/borndie/BornDieController.html#start(ch.javasoft.metabolic.efm.memory.IterableMemory)"><CODE>started</CODE></A> by specifying the initial columns. 
 Multiple threads might be used for the calculation, thus the initiating 
 thread must <A HREF="../../../../../ch/javasoft/metabolic/efm/borndie/BornDieController.html#awaitTermination()"><CODE>await termination</CODE></A> to get the result.
<P>

<P>
<HR>

<P>

<!-- ======== CONSTRUCTOR SUMMARY ======== -->

<A NAME="constructor_summary"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="2"><FONT SIZE="+2">
<B>Constructor Summary</B></FONT></TH>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD><CODE><B><A HREF="../../../../../ch/javasoft/metabolic/efm/borndie/BornDieController.html#BornDieController(ch.javasoft.metabolic.efm.column.ColumnHome, ch.javasoft.metabolic.efm.config.Config, ch.javasoft.metabolic.efm.borndie.model.BornDieEfmModel, ch.javasoft.metabolic.efm.memory.MemoryFactory)">BornDieController</A></B>(<A HREF="../../../../../ch/javasoft/metabolic/efm/column/ColumnHome.html" title="interface in ch.javasoft.metabolic.efm.column">ColumnHome</A>&lt;?,<A HREF="../../../../../ch/javasoft/metabolic/efm/borndie/BornDieController.html" title="type parameter in BornDieController">Col</A>&gt;&nbsp;columnHome,
                                   <A HREF="../../../../../ch/javasoft/metabolic/efm/config/Config.html" title="class in ch.javasoft.metabolic.efm.config">Config</A>&nbsp;config,
                                   <A HREF="../../../../../ch/javasoft/metabolic/efm/borndie/model/BornDieEfmModel.html" title="class in ch.javasoft.metabolic.efm.borndie.model">BornDieEfmModel</A>&nbsp;model,
                                   <A HREF="../../../../../ch/javasoft/metabolic/efm/memory/MemoryFactory.html" title="interface in ch.javasoft.metabolic.efm.memory">MemoryFactory</A>&nbsp;memoryFactory)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
</TABLE>
&nbsp;
<!-- ========== METHOD SUMMARY =========== -->

<A NAME="method_summary"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="2"><FONT SIZE="+2">
<B>Method Summary</B></FONT></TH>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../ch/javasoft/metabolic/efm/borndie/BornDieController.html#addPairingJob(ch.javasoft.metabolic.efm.borndie.job.PairingJob)">addPairingJob</A></B>(<A HREF="../../../../../ch/javasoft/metabolic/efm/borndie/job/PairingJob.html" title="interface in ch.javasoft.metabolic.efm.borndie.job">PairingJob</A>&lt;<A HREF="../../../../../ch/javasoft/metabolic/efm/borndie/BornDieController.html" title="type parameter in BornDieController">Col</A>&gt;&nbsp;job)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Adds the pairing job to the job queue.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;<A HREF="../../../../../ch/javasoft/metabolic/efm/memory/IterableMemory.html" title="interface in ch.javasoft.metabolic.efm.memory">IterableMemory</A>&lt;<A HREF="../../../../../ch/javasoft/metabolic/efm/borndie/BornDieController.html" title="type parameter in BornDieController">Col</A>&gt;</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../ch/javasoft/metabolic/efm/borndie/BornDieController.html#awaitTermination()">awaitTermination</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Blocks the calling thread until the born/die algorithm completes and
 returns the memory with the final modes.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;<A HREF="../../../../../ch/javasoft/metabolic/efm/column/ColumnHome.html" title="interface in ch.javasoft.metabolic.efm.column">ColumnHome</A>&lt;?,<A HREF="../../../../../ch/javasoft/metabolic/efm/borndie/BornDieController.html" title="type parameter in BornDieController">Col</A>&gt;</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../ch/javasoft/metabolic/efm/borndie/BornDieController.html#getColumnHome()">getColumnHome</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;<A HREF="../../../../../ch/javasoft/metabolic/efm/config/Config.html" title="class in ch.javasoft.metabolic.efm.config">Config</A></CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../ch/javasoft/metabolic/efm/borndie/BornDieController.html#getConfig()">getConfig</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;<A HREF="../../../../../ch/javasoft/metabolic/efm/borndie/debug/Debugger.html" title="interface in ch.javasoft.metabolic.efm.borndie.debug">Debugger</A></CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../ch/javasoft/metabolic/efm/borndie/BornDieController.html#getDebugger()">getDebugger</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;<A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Exception.html" title="class or interface in java.lang">Exception</A></CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../ch/javasoft/metabolic/efm/borndie/BornDieController.html#getException()">getException</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns the exception, if one has been set, or <code>null</code> otherwise.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;int</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../ch/javasoft/metabolic/efm/borndie/BornDieController.html#getIterationCount()">getIterationCount</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;<A HREF="../../../../../ch/javasoft/metabolic/efm/borndie/matrix/BornDieMatrix.html" title="interface in ch.javasoft.metabolic.efm.borndie.matrix">BornDieMatrix</A>&lt;<A HREF="../../../../../ch/javasoft/metabolic/efm/borndie/BornDieController.html" title="type parameter in BornDieController">Col</A>&gt;</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../ch/javasoft/metabolic/efm/borndie/BornDieController.html#getMatrix()">getMatrix</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;<A HREF="../../../../../ch/javasoft/metabolic/efm/memory/MemoryFactory.html" title="interface in ch.javasoft.metabolic.efm.memory">MemoryFactory</A></CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../ch/javasoft/metabolic/efm/borndie/BornDieController.html#getMemoryFactory()">getMemoryFactory</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;<A HREF="../../../../../ch/javasoft/metabolic/efm/model/NetworkEfmModel.html" title="interface in ch.javasoft.metabolic.efm.model">NetworkEfmModel</A></CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../ch/javasoft/metabolic/efm/borndie/BornDieController.html#getModel()">getModel</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../ch/javasoft/metabolic/efm/borndie/BornDieController.html#handleCommandException(java.lang.Exception)">handleCommandException</A></B>(<A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Exception.html" title="class or interface in java.lang">Exception</A>&nbsp;e)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Handle an exception which occurred in a command executed in its own 
 thread.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../ch/javasoft/metabolic/efm/borndie/BornDieController.html#handleJobException(ch.javasoft.metabolic.efm.borndie.job.PairingJob, java.lang.Exception)">handleJobException</A></B>(<A HREF="../../../../../ch/javasoft/metabolic/efm/borndie/job/PairingJob.html" title="interface in ch.javasoft.metabolic.efm.borndie.job">PairingJob</A>&lt;<A HREF="../../../../../ch/javasoft/metabolic/efm/borndie/BornDieController.html" title="type parameter in BornDieController">Col</A>&gt;&nbsp;job,
                                     <A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Exception.html" title="class or interface in java.lang">Exception</A>&nbsp;e)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Handle an exception which occurred in a pairing job executed in its own
 thread.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../ch/javasoft/metabolic/efm/borndie/BornDieController.html#start(ch.javasoft.metabolic.efm.memory.IterableMemory)">start</A></B>(<A HREF="../../../../../ch/javasoft/metabolic/efm/memory/IterableMemory.html" title="interface in ch.javasoft.metabolic.efm.memory">IterableMemory</A>&lt;<A HREF="../../../../../ch/javasoft/metabolic/efm/borndie/BornDieController.html" title="type parameter in BornDieController">Col</A>&gt;&nbsp;initialColumns)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Start the born/die algorithm.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../ch/javasoft/metabolic/efm/borndie/BornDieController.html#switchColumnToBearingStage(int)">switchColumnToBearingStage</A></B>(int&nbsp;bornColumn)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../ch/javasoft/metabolic/efm/borndie/BornDieController.html#terminate()">terminate</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Terminates the algorithm</TD>
</TR>
</TABLE>
&nbsp;<A NAME="methods_inherited_from_class_java.lang.Object"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#EEEEFF" CLASS="TableSubHeadingColor">
<TH ALIGN="left"><B>Methods inherited from class java.lang.<A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Object.html" title="class or interface in java.lang">Object</A></B></TH>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD><CODE><A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Object.html#clone()" title="class or interface in java.lang">clone</A>, <A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Object.html#equals(java.lang.Object)" title="class or interface in java.lang">equals</A>, <A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Object.html#finalize()" title="class or interface in java.lang">finalize</A>, <A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Object.html#getClass()" title="class or interface in java.lang">getClass</A>, <A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Object.html#hashCode()" title="class or interface in java.lang">hashCode</A>, <A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Object.html#notify()" title="class or interface in java.lang">notify</A>, <A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Object.html#notifyAll()" title="class or interface in java.lang">notifyAll</A>, <A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Object.html#toString()" title="class or interface in java.lang">toString</A>, <A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Object.html#wait()" title="class or interface in java.lang">wait</A>, <A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Object.html#wait(long)" title="class or interface in java.lang">wait</A>, <A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Object.html#wait(long, int)" title="class or interface in java.lang">wait</A></CODE></TD>
</TR>
</TABLE>
&nbsp;
<P>

<!-- ========= CONSTRUCTOR DETAIL ======== -->

<A NAME="constructor_detail"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="1"><FONT SIZE="+2">
<B>Constructor Detail</B></FONT></TH>
</TR>
</TABLE>

<A NAME="BornDieController(ch.javasoft.metabolic.efm.column.ColumnHome, ch.javasoft.metabolic.efm.config.Config, ch.javasoft.metabolic.efm.borndie.model.BornDieEfmModel, ch.javasoft.metabolic.efm.memory.MemoryFactory)"><!-- --></A><H3>
BornDieController</H3>
<PRE>
public <A HREF="../../../../../src-html/ch/javasoft/metabolic/efm/borndie/BornDieController.html#line.88"><B>BornDieController</B></A>(<A HREF="../../../../../ch/javasoft/metabolic/efm/column/ColumnHome.html" title="interface in ch.javasoft.metabolic.efm.column">ColumnHome</A>&lt;?,<A HREF="../../../../../ch/javasoft/metabolic/efm/borndie/BornDieController.html" title="type parameter in BornDieController">Col</A>&gt;&nbsp;columnHome,
                         <A HREF="../../../../../ch/javasoft/metabolic/efm/config/Config.html" title="class in ch.javasoft.metabolic.efm.config">Config</A>&nbsp;config,
                         <A HREF="../../../../../ch/javasoft/metabolic/efm/borndie/model/BornDieEfmModel.html" title="class in ch.javasoft.metabolic.efm.borndie.model">BornDieEfmModel</A>&nbsp;model,
                         <A HREF="../../../../../ch/javasoft/metabolic/efm/memory/MemoryFactory.html" title="interface in ch.javasoft.metabolic.efm.memory">MemoryFactory</A>&nbsp;memoryFactory)
                  throws <A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/io/IOException.html" title="class or interface in java.io">IOException</A></PRE>
<DL>
<DL>

<DT><B>Throws:</B>
<DD><CODE><A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/io/IOException.html" title="class or interface in java.io">IOException</A></CODE></DL>
</DL>

<!-- ============ METHOD DETAIL ========== -->

<A NAME="method_detail"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="1"><FONT SIZE="+2">
<B>Method Detail</B></FONT></TH>
</TR>
</TABLE>

<A NAME="getColumnHome()"><!-- --></A><H3>
getColumnHome</H3>
<PRE>
public <A HREF="../../../../../ch/javasoft/metabolic/efm/column/ColumnHome.html" title="interface in ch.javasoft.metabolic.efm.column">ColumnHome</A>&lt;?,<A HREF="../../../../../ch/javasoft/metabolic/efm/borndie/BornDieController.html" title="type parameter in BornDieController">Col</A>&gt; <A HREF="../../../../../src-html/ch/javasoft/metabolic/efm/borndie/BornDieController.html#line.103"><B>getColumnHome</B></A>()</PRE>
<DL>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="getConfig()"><!-- --></A><H3>
getConfig</H3>
<PRE>
public <A HREF="../../../../../ch/javasoft/metabolic/efm/config/Config.html" title="class in ch.javasoft.metabolic.efm.config">Config</A> <A HREF="../../../../../src-html/ch/javasoft/metabolic/efm/borndie/BornDieController.html#line.106"><B>getConfig</B></A>()</PRE>
<DL>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="getModel()"><!-- --></A><H3>
getModel</H3>
<PRE>
public <A HREF="../../../../../ch/javasoft/metabolic/efm/model/NetworkEfmModel.html" title="interface in ch.javasoft.metabolic.efm.model">NetworkEfmModel</A> <A HREF="../../../../../src-html/ch/javasoft/metabolic/efm/borndie/BornDieController.html#line.109"><B>getModel</B></A>()</PRE>
<DL>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="getMemoryFactory()"><!-- --></A><H3>
getMemoryFactory</H3>
<PRE>
public <A HREF="../../../../../ch/javasoft/metabolic/efm/memory/MemoryFactory.html" title="interface in ch.javasoft.metabolic.efm.memory">MemoryFactory</A> <A HREF="../../../../../src-html/ch/javasoft/metabolic/efm/borndie/BornDieController.html#line.115"><B>getMemoryFactory</B></A>()</PRE>
<DL>
<DD><DL>

<DT><B>Returns:</B><DD>the memory factory</DL>
</DD>
</DL>
<HR>

<A NAME="getMatrix()"><!-- --></A><H3>
getMatrix</H3>
<PRE>
public <A HREF="../../../../../ch/javasoft/metabolic/efm/borndie/matrix/BornDieMatrix.html" title="interface in ch.javasoft.metabolic.efm.borndie.matrix">BornDieMatrix</A>&lt;<A HREF="../../../../../ch/javasoft/metabolic/efm/borndie/BornDieController.html" title="type parameter in BornDieController">Col</A>&gt; <A HREF="../../../../../src-html/ch/javasoft/metabolic/efm/borndie/BornDieController.html#line.118"><B>getMatrix</B></A>()</PRE>
<DL>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="getIterationCount()"><!-- --></A><H3>
getIterationCount</H3>
<PRE>
public int <A HREF="../../../../../src-html/ch/javasoft/metabolic/efm/borndie/BornDieController.html#line.121"><B>getIterationCount</B></A>()</PRE>
<DL>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="addPairingJob(ch.javasoft.metabolic.efm.borndie.job.PairingJob)"><!-- --></A><H3>
addPairingJob</H3>
<PRE>
public void <A HREF="../../../../../src-html/ch/javasoft/metabolic/efm/borndie/BornDieController.html#line.131"><B>addPairingJob</B></A>(<A HREF="../../../../../ch/javasoft/metabolic/efm/borndie/job/PairingJob.html" title="interface in ch.javasoft.metabolic.efm.borndie.job">PairingJob</A>&lt;<A HREF="../../../../../ch/javasoft/metabolic/efm/borndie/BornDieController.html" title="type parameter in BornDieController">Col</A>&gt;&nbsp;job)</PRE>
<DL>
<DD>Adds the pairing job to the job queue. Might block the caller if the job
 queue has limited capacity.
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>job</CODE> - the job to add to the queue</DL>
</DD>
</DL>
<HR>

<A NAME="start(ch.javasoft.metabolic.efm.memory.IterableMemory)"><!-- --></A><H3>
start</H3>
<PRE>
public void <A HREF="../../../../../src-html/ch/javasoft/metabolic/efm/borndie/BornDieController.html#line.148"><B>start</B></A>(<A HREF="../../../../../ch/javasoft/metabolic/efm/memory/IterableMemory.html" title="interface in ch.javasoft.metabolic.efm.memory">IterableMemory</A>&lt;<A HREF="../../../../../ch/javasoft/metabolic/efm/borndie/BornDieController.html" title="type parameter in BornDieController">Col</A>&gt;&nbsp;initialColumns)
           throws <A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/io/IOException.html" title="class or interface in java.io">IOException</A></PRE>
<DL>
<DD>Start the born/die algorithm. The algorithm might use multiple threads
 and does not block. Use <A HREF="../../../../../ch/javasoft/metabolic/efm/borndie/BornDieController.html#awaitTermination()"><CODE>awaitTermination()</CODE></A> to wait until the
 calculation is complete.
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>initialColumns</CODE> - the initial columns from the kernel matrix
<DT><B>Throws:</B>
<DD><CODE><A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/io/IOException.html" title="class or interface in java.io">IOException</A></CODE> - if a i/o exception occurs</DL>
</DD>
</DL>
<HR>

<A NAME="terminate()"><!-- --></A><H3>
terminate</H3>
<PRE>
public void <A HREF="../../../../../src-html/ch/javasoft/metabolic/efm/borndie/BornDieController.html#line.159"><B>terminate</B></A>()
               throws <A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/io/IOException.html" title="class or interface in java.io">IOException</A></PRE>
<DL>
<DD>Terminates the algorithm
<P>
<DD><DL>

<DT><B>Throws:</B>
<DD><CODE><A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/io/IOException.html" title="class or interface in java.io">IOException</A></CODE></DL>
</DD>
</DL>
<HR>

<A NAME="awaitTermination()"><!-- --></A><H3>
awaitTermination</H3>
<PRE>
public <A HREF="../../../../../ch/javasoft/metabolic/efm/memory/IterableMemory.html" title="interface in ch.javasoft.metabolic.efm.memory">IterableMemory</A>&lt;<A HREF="../../../../../ch/javasoft/metabolic/efm/borndie/BornDieController.html" title="type parameter in BornDieController">Col</A>&gt; <A HREF="../../../../../src-html/ch/javasoft/metabolic/efm/borndie/BornDieController.html#line.186"><B>awaitTermination</B></A>()
                                                    throws <A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/io/IOException.html" title="class or interface in java.io">IOException</A></PRE>
<DL>
<DD>Blocks the calling thread until the born/die algorithm completes and
 returns the memory with the final modes.
<P>
<DD><DL>

<DT><B>Returns:</B><DD>the final modes, the algorithm's result
<DT><B>Throws:</B>
<DD><CODE><A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/io/IOException.html" title="class or interface in java.io">IOException</A></CODE> - if an I/O exception occurred
<DD><CODE><A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/IllegalStateException.html" title="class or interface in java.lang">IllegalStateException</A></CODE> - if waiting was interrupted</DL>
</DD>
</DL>
<HR>

<A NAME="switchColumnToBearingStage(int)"><!-- --></A><H3>
switchColumnToBearingStage</H3>
<PRE>
public void <A HREF="../../../../../src-html/ch/javasoft/metabolic/efm/borndie/BornDieController.html#line.217"><B>switchColumnToBearingStage</B></A>(int&nbsp;bornColumn)
                                throws <A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/io/IOException.html" title="class or interface in java.io">IOException</A></PRE>
<DL>
<DD><DL>

<DT><B>Throws:</B>
<DD><CODE><A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/io/IOException.html" title="class or interface in java.io">IOException</A></CODE></DL>
</DD>
</DL>
<HR>

<A NAME="handleJobException(ch.javasoft.metabolic.efm.borndie.job.PairingJob, java.lang.Exception)"><!-- --></A><H3>
handleJobException</H3>
<PRE>
public void <A HREF="../../../../../src-html/ch/javasoft/metabolic/efm/borndie/BornDieController.html#line.269"><B>handleJobException</B></A>(<A HREF="../../../../../ch/javasoft/metabolic/efm/borndie/job/PairingJob.html" title="interface in ch.javasoft.metabolic.efm.borndie.job">PairingJob</A>&lt;<A HREF="../../../../../ch/javasoft/metabolic/efm/borndie/BornDieController.html" title="type parameter in BornDieController">Col</A>&gt;&nbsp;job,
                               <A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Exception.html" title="class or interface in java.lang">Exception</A>&nbsp;e)</PRE>
<DL>
<DD>Handle an exception which occurred in a pairing job executed in its own
 thread. If it was the first exception, it is kept and rethrown after 
 terminating the algorithm.
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>job</CODE> - the job that caused the exception<DD><CODE>e</CODE> - the exception which occurred</DL>
</DD>
</DL>
<HR>

<A NAME="handleCommandException(java.lang.Exception)"><!-- --></A><H3>
handleCommandException</H3>
<PRE>
public void <A HREF="../../../../../src-html/ch/javasoft/metabolic/efm/borndie/BornDieController.html#line.279"><B>handleCommandException</B></A>(<A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Exception.html" title="class or interface in java.lang">Exception</A>&nbsp;e)</PRE>
<DL>
<DD>Handle an exception which occurred in a command executed in its own 
 thread. If it was the first exception, it is kept and rethrown after 
 terminating the algorithm.
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>e</CODE> - the exception which occurred</DL>
</DD>
</DL>
<HR>

<A NAME="getException()"><!-- --></A><H3>
getException</H3>
<PRE>
public <A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Exception.html" title="class or interface in java.lang">Exception</A> <A HREF="../../../../../src-html/ch/javasoft/metabolic/efm/borndie/BornDieController.html#line.292"><B>getException</B></A>()</PRE>
<DL>
<DD>Returns the exception, if one has been set, or <code>null</code> otherwise.
<P>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="getDebugger()"><!-- --></A><H3>
getDebugger</H3>
<PRE>
public <A HREF="../../../../../ch/javasoft/metabolic/efm/borndie/debug/Debugger.html" title="interface in ch.javasoft.metabolic.efm.borndie.debug">Debugger</A> <A HREF="../../../../../src-html/ch/javasoft/metabolic/efm/borndie/BornDieController.html#line.296"><B>getDebugger</B></A>()</PRE>
<DL>
<DD><DL>
</DL>
</DD>
</DL>
<!-- ========= END OF CLASS DATA ========= -->
<HR>


<!-- ======= START OF BOTTOM NAVBAR ====== -->
<A NAME="navbar_bottom"><!-- --></A>
<A HREF="#skip-navbar_bottom" title="Skip navigation links"></A>
<TABLE BORDER="0" WIDTH="100%" CELLPADDING="1" CELLSPACING="0" SUMMARY="">
<TR>
<TD COLSPAN=2 BGCOLOR="#EEEEFF" CLASS="NavBarCell1">
<A NAME="navbar_bottom_firstrow"><!-- --></A>
<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="3" SUMMARY="">
  <TR ALIGN="center" VALIGN="top">
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../../overview-summary.html"><FONT CLASS="NavBarFont1"><B>Overview</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="package-summary.html"><FONT CLASS="NavBarFont1"><B>Package</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#FFFFFF" CLASS="NavBarCell1Rev"> &nbsp;<FONT CLASS="NavBarFont1Rev"><B>Class</B></FONT>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="class-use/BornDieController.html"><FONT CLASS="NavBarFont1"><B>Use</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="package-tree.html"><FONT CLASS="NavBarFont1"><B>Tree</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../../deprecated-list.html"><FONT CLASS="NavBarFont1"><B>Deprecated</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../../index-files/index-1.html"><FONT CLASS="NavBarFont1"><B>Index</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../../help-doc.html"><FONT CLASS="NavBarFont1"><B>Help</B></FONT></A>&nbsp;</TD>
  </TR>
</TABLE>
</TD>
<TD ALIGN="right" VALIGN="top" ROWSPAN=3><EM>
</EM>
</TD>
</TR>

<TR>
<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
&nbsp;PREV CLASS&nbsp;
&nbsp;<A HREF="../../../../../ch/javasoft/metabolic/efm/borndie/BornDieDoubleDescriptionImpl.html" title="class in ch.javasoft.metabolic.efm.borndie"><B>NEXT CLASS</B></A></FONT></TD>
<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
  <A HREF="../../../../../index.html?ch/javasoft/metabolic/efm/borndie/BornDieController.html" target="_top"><B>FRAMES</B></A>  &nbsp;
&nbsp;<A HREF="BornDieController.html" target="_top"><B>NO FRAMES</B></A>  &nbsp;
&nbsp;<SCRIPT type="text/javascript">
  <!--
  if(window==top) {
    document.writeln('<A HREF="../../../../../allclasses-noframe.html"><B>All Classes</B></A>');
  }
  //-->
</SCRIPT>
<NOSCRIPT>
  <A HREF="../../../../../allclasses-noframe.html"><B>All Classes</B></A>
</NOSCRIPT>


</FONT></TD>
</TR>
<TR>
<TD VALIGN="top" CLASS="NavBarCell3"><FONT SIZE="-2">
  SUMMARY:&nbsp;NESTED&nbsp;|&nbsp;FIELD&nbsp;|&nbsp;<A HREF="#constructor_summary">CONSTR</A>&nbsp;|&nbsp;<A HREF="#method_summary">METHOD</A></FONT></TD>
<TD VALIGN="top" CLASS="NavBarCell3"><FONT SIZE="-2">
DETAIL:&nbsp;FIELD&nbsp;|&nbsp;<A HREF="#constructor_detail">CONSTR</A>&nbsp;|&nbsp;<A HREF="#method_detail">METHOD</A></FONT></TD>
</TR>
</TABLE>
<A NAME="skip-navbar_bottom"></A>
<!-- ======== END OF BOTTOM NAVBAR ======= -->

<HR>

</BODY>
</HTML>
